const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const task_dependencies = sequelize.define(
    'task_dependencies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  task_dependencies.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity














































//end loop



    db.task_dependencies.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.task_dependencies.belongsTo(db.tasks, {
      as: 'task',
      foreignKey: {
        name: 'taskId',
      },
      constraints: false,
    });

    db.task_dependencies.belongsTo(db.tasks, {
      as: 'depends_on_task',
      foreignKey: {
        name: 'depends_on_taskId',
      },
      constraints: false,
    });

    db.task_dependencies.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.task_dependencies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.task_dependencies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return task_dependencies;
};


